﻿Imports ServerSIP.ServerSIP

Public Class CallPickupForm

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub BtnAddCallPickupGroup_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnAddCallPickupGroup.Click

        If ComboPickupGroup.Text = "" Then
            MessageBox.Show("Please enter pickup group name.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If

        If ComboPickupGroup.FindStringExact(ComboPickupGroup.Text) <> -1 Then

            If MessageBox.Show("Pickup Group already exists, do you want to continue?", "VaxVoIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = DialogResult.No Then
                Return
            End If
        End If

        Dim objMemberList As ArrayList = New ArrayList()
        GetMemberNameAll(objMemberList)

        If Not cVaxPickUpGroup.AddCallPickUpGroup(ComboPickupGroup.Text, objMemberList) Then
            MessageBox.Show("Pickup Group couldn't be added.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If Not ComboPickupGroup.Items.Contains(ComboPickupGroup.Text) Then
            ComboPickupGroup.Items.Add(ComboPickupGroup.Text)
        End If

        MessageBox.Show("PickUp Group added/updated successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnRemoveCallPickupGroup_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnRemoveCallPickupGroup.Click

        If (ComboPickupGroup.Text = "" Or (Not ComboPickupGroup.Items.Contains(ComboPickupGroup.Text))) Then
            Return
        End If

        Dim nIndex As Integer = ComboPickupGroup.FindStringExact(ComboPickupGroup.Text)
        If nIndex = -1 Then Return

        cVaxPickUpGroup.RemoveCallPickUpGroup(ComboPickupGroup.Text)
        ComboPickupGroup.Items.RemoveAt(nIndex)

        ClearDlgUI()

        If ComboPickupGroup.Items.Count > 0 Then
            ComboPickupGroup.SelectedIndex = 0
        End If

        ShowPickupGroupDetails()
        MessageBox.Show("PickUp Group removed successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnClearCallPickupGroup_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearCallPickupGroup.Click

        ComboPickupGroup.Text = ""

        If ComboMemberName.Items.Count > 0 Then
            ComboMemberName.SelectedIndex = 0
        End If

        ListBoxMember.Items.Clear()

    End Sub

    Private Sub BtnAddAgent_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnAddAgent.Click

        If ListBoxMember.FindStringExact(ComboMemberName.Text) <> -1 Then
            Return
        End If

        ListBoxMember.Items.Insert(0, ComboMemberName.Text)

    End Sub

    Private Sub BtnRemoveAgent_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnRemoveAgent.Click
        ListBoxMember.Items.Remove(ListBoxMember.SelectedItem)
    End Sub

    Private Sub BtnClearAgent_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearAgent.Click
        ListBoxMember.Items.Clear()
    End Sub

    Private Sub ClearDlgUI()
        ComboPickupGroup.Text = ""
        ListBoxMember.Items.Clear()
    End Sub

    Private Sub GetMemberNameAll(ByRef objList As ArrayList)
        For Each sMemberName As String In ListBoxMember.Items
            objList.Add(sMemberName)
        Next
    End Sub

    Private Sub AddUsers()

        ComboMemberName.Items.Clear()

        Dim objListUsers As ArrayList = New ArrayList()

        cStoreUser.GetUserAll(objListUsers)
        If objListUsers.Count <= 0 Then Return

        For nIndex As Integer = 0 To objListUsers.Count - 1
            ComboMemberName.Items.Add(objListUsers(nIndex))
        Next

        If ComboMemberName.SelectedIndex = -1 AndAlso ComboMemberName.Items.Count > 0 Then
            ComboMemberName.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddPickupGroups()

        ComboPickupGroup.Items.Clear()

        Dim objList As ArrayList = New ArrayList()
        cStoreCallPickUp.GetGroupNameAll(objList)

        If objList.Count <= 0 Then
            Return
        End If

        For Each sGroupName As String In objList
            ComboPickupGroup.Items.Add(sGroupName)
        Next

        If ComboPickupGroup.Items.Count > 0 Then
            ComboPickupGroup.SelectedIndex = 0
        End If

    End Sub

    Public Sub OnSetActive()
        AddUsers()
        AddPickupGroups()
        ShowPickupGroupDetails()
    End Sub

    Private Sub ComboPickupGroup_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ComboPickupGroup.SelectedIndexChanged
        ShowPickupGroupDetails()
    End Sub

    Private Sub ShowPickupGroupDetails()

        Dim sGroupName As String = ComboPickupGroup.Text
        If sGroupName.Length = 0 Then Return

        Dim objMemberList As ArrayList = New ArrayList()
        If Not cStoreCallPickUp.GetGroup(sGroupName, objMemberList) Then Return

        ListBoxMember.Items.Clear()

        For Each sMemberName As String In objMemberList
            ListBoxMember.Items.Add(sMemberName)
        Next

    End Sub

End Class
