Imports ServerSIP.ServerSIP

Public Class GeneralForm

    Private Const STATUS_MSG_SERVER_RUNNING As String = "SIP SERVER IS RUNNING."
    Private Const STATUS_MSG_SERVER_NOT_RUNNING As String = "SIP SERVER IS NOT RUNNING."

    Private Const START_BUTTON_TITLE As String = "Start"
    Private Const STOP_BUTTON_TITLE As String = "Stop"

    Private m_bServerRunning As Boolean

    Private m_objUsageCPU As PerformanceCounter = New PerformanceCounter("Processor", "% Processor Time", "_Total")

    Public Sub New()

        InitializeComponent()

        LabelServerStatus.Text = STATUS_MSG_SERVER_NOT_RUNNING
        BtnStartServerSIP.Text = START_BUTTON_TITLE

        m_bServerRunning = False

    End Sub

    Private Sub GeneralForm_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

        Dim nListenPortSIP As Integer
        nListenPortSIP = cStoreCOMM.GetListenPortSIP()

        EditListenPort.Text = nListenPortSIP.ToString()

        Dim sMusicHold As String = "", sMusicDialTone As String = "", sMusicCallPark As String = ""
        cStoreCOMM.GetMusicFiles(sMusicHold, sMusicDialTone, sMusicCallPark)

        EditPlayWaveHold.Text = sMusicHold
        EditPlayWaveDialTone.Text = sMusicDialTone
        EditPlayWaveCallParking.Text = sMusicCallPark

        UpdateStats()
        TimerGeneral.Enabled = True

    End Sub

    Private Sub BtnStartServerSIP_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnStartServerSIP.Click

        If m_bServerRunning Then
            cVaxServerSIP.mVaxSIP.StopServer()
            TimerGeneral.Enabled = False

            LabelServerStatus.Text = STATUS_MSG_SERVER_NOT_RUNNING
            BtnStartServerSIP.Text = START_BUTTON_TITLE

            m_bServerRunning = False
            Return
        End If

        Dim bStatusRun As Boolean = cVaxServerSIP.mVaxSIP.StartServer(Convert.ToInt32(EditListenPort.Text))

        If bStatusRun = False Then
            LabelServerStatus.Text = "UNABLE TO START SIP SERVER (SEE ERROR LOG)."
            Return
        End If

        cStoreCOMM.SetListenPortSIP(Convert.ToInt32(EditListenPort.Text))

        cVaxServerSIP.mVaxSIP.LoadMusicFiles(EditPlayWaveHold.Text, EditPlayWaveDialTone.Text, EditPlayWaveCallParking.Text)
        TimerGeneral.Enabled = True

        LabelServerStatus.Text = STATUS_MSG_SERVER_RUNNING
        BtnStartServerSIP.Text = STOP_BUTTON_TITLE

        m_bServerRunning = True

    End Sub

    Private Sub TimerGeneral_Tick(ByVal sender As Object, ByVal e As EventArgs)
        UpdateStats()
    End Sub

    Private Sub UpdateStats()
        LabelTotalCalls.Text = cVaxServerSIP.mVaxSIP.GetCallCount().ToString()
        LabelTotalUsers.Text = cVaxUser.GetRegisteredUserCount().ToString()

        LabelUsageCPU.Text = GetUsageCPU().ToString()
        LabelUsageMEM.Text = GetAvailableMEM().ToString()
    End Sub

    Public Sub OnSetActive()
    End Sub

    Public Function GetAvailableMEM() As Long
        Dim objUsageMEM As PerformanceCounter = New PerformanceCounter("Memory", "Available KBytes")
        Return CLng(objUsageMEM.NextValue())
    End Function

    Public Function GetUsageCPU() As Long
        Return CLng(m_objUsageCPU.NextValue())
    End Function

End Class
