﻿Imports ServerSIP.ServerSIP

Public Class QueueForm

    Public Sub New()
        InitializeComponent()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnAddQueue_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnAddQueue.Click

        If Not AddQueueChecks() Then
            Return
        End If

        If ComboQueueName.FindStringExact(ComboQueueName.Text) <> -1 Then
            If MessageBox.Show("Queue already exists, do you want to continue?", "VaxVoIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = DialogResult.No Then
                Return
            End If
        End If

        Dim objAgentList As ArrayList = New ArrayList()
        GetAgentNameAll(objAgentList)

        If Not cVaxQueue.AddQueue(ComboQueueName.Text, GetProcessMode(), GetProcessType(), objAgentList, EditQueueMusicFile.Text, EditQueueDialToneFile.Text) Then
            MessageBox.Show("Queue could not be added/updated or Please start the server first.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If Not ComboQueueName.Items.Contains(ComboQueueName.Text) Then
            ComboQueueName.Items.Add(ComboQueueName.Text)
        End If

        MessageBox.Show("Queue added/updated successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Function AddQueueChecks() As Boolean

        If ComboQueueName.Text.Length = 0 Then
            MessageBox.Show("Please enter Queue Name", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If ComboProcessMode.Text.Length = 0 Then
            MessageBox.Show("Please select Process Mode", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If ComboProcessMode.Text.Length = 0 Then
            MessageBox.Show("Please select Process Mode Type Free/Any", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Return True

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnRemoveQueue_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnRemoveQueue.Click

        If ComboQueueName.Text = "" Then
            Return
        End If

        cVaxQueue.RemoveQueue(ComboQueueName.Text)
        ComboQueueName.Items.Remove(ComboQueueName.Text)

        ClearDlgUI()

        If ComboQueueName.Items.Count > 0 Then
            ComboQueueName.SelectedIndex = 0
        End If

        ShowQueueDetails()
        MessageBox.Show("Queue removed successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnQueueClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnQueueClear.Click
        ClearDlgUI()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnAddQueueAgent_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnAddQueueAgent.Click

        If ListBoxLogin.FindStringExact(ComboAgentName.Text) <> -1 Then
            Return
        End If

        ListBoxLogin.Items.Insert(0, ComboAgentName.Text)

    End Sub

    Private Sub BtnRemoveQueueAgent_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnRemoveAgent.Click
        ListBoxLogin.Items.Remove(ListBoxLogin.SelectedItem)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnClearQueueAgent_Click(ByVal sender As Object, ByVal e As EventArgs) Handles BtnClearAgent.Click
        ClearDlgUI()
    End Sub

    Private Sub ClearDlgUI()

        ComboQueueName.Text = ""

        If ComboProcessMode.Items.Count > 0 Then ComboProcessMode.SelectedIndex = 0
        If ComboProcessType.Items.Count > 0 Then ComboProcessType.SelectedIndex = 0

        If ComboAgentName.Items.Count > 0 Then ComboAgentName.SelectedIndex = 0

        EditQueueMusicFile.Text = ""
        EditQueueDialToneFile.Text = ""

        ListBoxLogin.Items.Clear()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub GetAgentNameAll(ByRef objList As ArrayList)
        For Each sAgentName As String In ListBoxLogin.Items
            objList.Add(sAgentName)
        Next
    End Sub

    Private Function GetProcessMode() As Integer

        If ComboProcessMode.SelectedIndex = -1 Then
            MessageBox.Show("Please select a process mode.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return -1
        End If

        Return ComboProcessMode.SelectedIndex

    End Function

    Private Function GetProcessType() As Integer

        If ComboProcessType.SelectedIndex = -1 Then
            MessageBox.Show("Please select a process type.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return -1
        End If

        Return ComboProcessType.SelectedIndex

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddProcessMode()

        ComboProcessMode.Items.Clear()

        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_RING_ALL)
        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_HUNT_RANDOM)
        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_ROUND_ROBIN)
        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_LEAST_ANSWERED)
        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_LEAST_TALK_TIME)
        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_LONGEST_WAITING)
        ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_PRIORITIZED_HUNT)

        ComboProcessMode.SelectedIndex = 0

    End Sub

    Private Sub AddProcessType()

        ComboProcessType.Items.Clear()

        ComboProcessType.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_PROCESS_TYPE_FREE)
        ComboProcessType.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_PROCESS_TYPE_ANY)

        ComboProcessType.SelectedIndex = 0

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddUsers()

        ComboAgentName.Items.Clear()

        Dim objListUsers As ArrayList = New ArrayList()
        cStoreUser.GetUserAll(objListUsers)

        If objListUsers.Count <= 0 Then
            Return
        End If

        For nIndex As Integer = 0 To objListUsers.Count - 1
            ComboAgentName.Items.Add(objListUsers(nIndex))
        Next

        If ComboAgentName.SelectedIndex = -1 AndAlso ComboAgentName.Items.Count > 0 Then
            ComboAgentName.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddQueues()

        ComboQueueName.Items.Clear()

        Dim objListQueueName As ArrayList = New ArrayList()
        cStoreQueue.GetQueueNameAll(objListQueueName)

        If objListQueueName.Count <= 0 Then
            Return
        End If

        For Each sQueueName As String In objListQueueName
            ComboQueueName.Items.Add(sQueueName)
        Next

        If ComboQueueName.Items.Count > 0 Then
            ComboQueueName.SelectedIndex = 0
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnSetActive()
        AddUsers()
        AddProcessMode()
        AddProcessType()
        AddQueues()
        ShowQueueDetails()
    End Sub

    Private Sub ComboQueueName_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ComboQueueName.SelectedIndexChanged
        ShowQueueDetails()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ShowQueueDetails()

        Dim sQueueName As String = ComboQueueName.Text
        If sQueueName.Length = 0 Then Return

        Dim nProcessMode As Integer = -1, nProcessType As Integer = -1
        Dim sQueueMusicFile As String = "", sQueueDialToneFile As String = ""

        Dim objAgentList As ArrayList = New ArrayList()
        cStoreQueue.GetQueue(sQueueName, nProcessMode, nProcessType, objAgentList, sQueueMusicFile, sQueueDialToneFile)

        If ComboProcessMode.Items.Count > 0 Then
            ComboProcessMode.SelectedIndex = 0
        End If

        If ComboProcessType.Items.Count > 0 Then
            ComboProcessType.SelectedIndex = 0
        End If

        EditQueueMusicFile.Text = sQueueMusicFile
        EditQueueDialToneFile.Text = sQueueDialToneFile

        ListBoxLogin.Items.Clear()

        For Each sUserName As String In objAgentList
            ListBoxLogin.Items.Add(sUserName)
        Next

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////////////

End Class

