﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxCallParking

        Private Shared m_nMusicCallParkingId As Integer = -1

        Public Shared Sub ResetAll()
            m_nMusicCallParkingId = -1
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadMusic(ByVal sFileName As String) As Boolean

            If m_nMusicCallParkingId <> -1 Then
                cVaxServerSIP.mVaxSIP.UnLoadWaveID(m_nMusicCallParkingId)
                m_nMusicCallParkingId = -1
            End If

            m_nMusicCallParkingId = cVaxServerSIP.mVaxSIP.LoadWaveFile(sFileName)
            Return (m_nMusicCallParkingId <> -1)

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sRouteUID As String)
            StopMusic(nSessionId)
            cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferee As String, ByVal sTransferTo As String, ByVal sRouteUID As String)

            If Not cVaxServerSIP.mVaxSIP.AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, sTransferTo, "", sRouteUID, 30) Then Return

            Dim nChannelId As Integer = cVaxServerCOM.VAX_CALL_CHANNEL_ZERO
            If nTransfererChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ZERO Then nChannelId = cVaxServerCOM.VAX_CALL_CHANNEL_ONE

            StartMusic(nTransfererSessionId, nChannelId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function StartMusic(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Boolean

            Dim nMusicId As Integer = m_nMusicCallParkingId
            If nMusicId = -1 Then Return False

            Return cVaxServerSIP.mVaxSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, True, 0)

        End Function

        Private Shared Sub StopMusic(ByVal nSessionId As Integer)

            If m_nMusicCallParkingId = -1 Then Return
            cVaxServerSIP.mVaxSIP.PlayWaveStopToCallSession(nSessionId, -1, -1)

        End Sub

    End Class

End Namespace
