﻿Imports System
Imports System.Collections
Imports System.Collections.Generic

Namespace ServerSIP

    Class cUserRouteDetails : Inherits cVaxHashTextData

        Public m_sUserPrefix As String = "", m_sToPeerName As String = "", m_sDialPrefix As String = ""

        Public Sub New()
        End Sub

    End Class

    Class cLineRouteDetails : Inherits cVaxHashTextData

        Public m_sLineName As String = "", m_sRoomName As String = "", m_sToPeerName As String = "", m_sQueueName As String = "", m_sRingGroupName As String = ""
        Public m_bRejected As Boolean = False

        Public Sub New()
        End Sub
    End Class

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Class cVaxCallSessionRoute

        Private m_objListUserRoute As cVaxHashText = Nothing
        Private m_objListLineRoute As cVaxHashText = Nothing

        Public Sub New()
            m_objListUserRoute = New cVaxHashText(64)
            m_objListLineRoute = New cVaxHashText(64)
        End Sub

        Private Function FindUserRoute(ByVal sUserName As String) As cUserRouteDetails
            Return CType(m_objListUserRoute.FindData(sUserName), cUserRouteDetails)
        End Function

        Private Function FindLineRoute(ByVal sLineName As String) As cLineRouteDetails
            Return CType(m_objListLineRoute.FindData(sLineName), cLineRouteDetails)
        End Function

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

        Private Function GetUserRouteDetails(ByVal sUserName As String, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef sToPeerName As String) As Boolean

            Dim objUserRoute As cUserRouteDetails = FindUserRoute(sUserName)
            If objUserRoute Is Nothing Then Return False

            sUserPrefix = objUserRoute.m_sUserPrefix
            sDialPrefix = objUserRoute.m_sDialPrefix
            sToPeerName = objUserRoute.m_sToPeerName

            Return True

        End Function

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

        Private Function GetLineRouteDetails(ByVal sLineName As String, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

            Dim objLineRoute As cLineRouteDetails = FindLineRoute(sLineName)
            If objLineRoute Is Nothing Then Return False

            sToPeerName = objLineRoute.m_sToPeerName
            bRejected = objLineRoute.m_bRejected
            sRoomName = objLineRoute.m_sRoomName
            sQueueName = objLineRoute.m_sQueueName
            sRingGroupName = objLineRoute.m_sRingGroupName

            Return True

        End Function

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

        Public Sub AddUserRoute(ByVal sUserName As String, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal sToPeerName As String)

            RemoveUserRoute(sUserName)

            Dim objUserRoute As cUserRouteDetails = New cUserRouteDetails()

            objUserRoute.m_sUserPrefix = sUserPrefix
            objUserRoute.m_sDialPrefix = sDialPrefix
            objUserRoute.m_sToPeerName = sToPeerName

            m_objListUserRoute.AddData(sUserName, objUserRoute)

        End Sub

        Public Sub RemoveUserRoute(ByVal sUserName As String)
            m_objListUserRoute.RemoveData(sUserName)
        End Sub

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

        Public Sub AddLineRoute(ByVal sLineName As String, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String)

            RemoveLineRoute(sLineName)

            Dim objLineRoute As cLineRouteDetails = New cLineRouteDetails()

            objLineRoute.m_sToPeerName = sToPeerName
            objLineRoute.m_bRejected = bRejected
            objLineRoute.m_sRoomName = sRoomName
            objLineRoute.m_sQueueName = sQueueName
            objLineRoute.m_sRingGroupName = sRingGroupName

            m_objListLineRoute.AddData(sLineName, objLineRoute)

        End Sub

        Public Sub RemoveLineRoute(ByVal sLineName As String)
            m_objListLineRoute.RemoveData(sLineName)
        End Sub

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

        Public Function GetUserRouteInfo(ByVal sUserName As String, ByVal sDialNo As String, ByRef sDialToNo As String, ByRef sToPeerName As String) As Boolean

            Dim sUserPrefix As String = "", sDialPrefix As String = ""
            Dim bResult As Boolean = GetUserRouteDetails(sUserName, sUserPrefix, sDialPrefix, sToPeerName)

            'USER-ROUTE not found. Make it U2U call.

            If bResult = False OrElse sToPeerName.Length = 0 OrElse sUserPrefix.Length = 0 Then
                sDialToNo = sDialNo
                sToPeerName = sDialNo
                Return True
            End If

            Dim nUserPrefixLen As Integer = sUserPrefix.Length

            'Check if first 'N' charachters are equal to sUserPrefix. If YES; Modify it according to dialplan.

            If sDialNo.Substring(0, nUserPrefixLen) = sUserPrefix Then

                Dim sCallTo As String = sDialNo.Remove(0, nUserPrefixLen)
                sDialToNo = sDialPrefix & sCallTo

            Else

                'Make it USER_TO_USER call.

                sDialToNo = sDialNo
                sToPeerName = sDialNo
            End If

            Return True

        End Function

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

        Public Sub GetLineRouteInfo(ByVal sLineName As String, ByVal sDialNo As String, ByRef sDialToNo As String, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String)

            Dim bResult As Boolean = GetLineRouteDetails(sLineName, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

            If bResult = True Then
                If sToPeerName.Length <> 0 Then sDialToNo = sToPeerName
                Return
            End If

            sDialToNo = sDialNo
            sToPeerName = sDialNo

        End Sub

        '//////////////////////////////////////////////////////////////////////////////
        '//////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
