﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxLine

        Public Shared Sub OnLineRegisterTrying(ByVal sLineName As String)
            Dim sStatus As String = sLineName & " " & cVaxDefine.LINE_REG_TRYING
            cVaxServerSIP.mVaxSIP.GenStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
            Dim sStatus As String = sLineName & " Register Failed: " & sReasonPhrase
            cVaxServerSIP.mVaxSIP.GenStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnLineRegisterSuccess(ByVal sLineName As String)
            Dim sStatus As String = sLineName & " " & cVaxDefine.LINE_REG_SUCCESS
            cVaxServerSIP.mVaxSIP.GenStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddLine(ByVal sLineName As String, ByVal nLineType As Integer, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sServerAddr As String, ByVal nServerPort As Integer, ByVal sAudioCodecList As String, ByVal bRegister As Boolean, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sLineName.Length = 0) Then
                Return False
            End If

            RemoveLine(sLineName)

            If Not cVaxServerSIP.mVaxSIP.AddLine(sLineName, nLineType, "", "", sAuthUser, sAuthPwd, "", sServerAddr, nServerPort, sAudioCodecList) Then
                Return False
            End If


            cVaxCallSession.AddLineRoute(sLineName, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

            If bRegister Then
                cVaxServerSIP.mVaxSIP.RegisterLine(sLineName, 1800)
            End If

            cStoreLine.AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveLine(ByVal sLineName As String)

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sLineName.Length = 0) Then Return

            cVaxServerSIP.mVaxSIP.RemoveLine(sLineName)
            cVaxCallSession.RemoveLineRoute(sLineName)
            cStoreLine.RemoveLine(sLineName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub LoadLine()

            If Not cVaxServerSIP.mVaxSIP.IsInitialized() Then
                Return
            End If


            Dim objListLines As ArrayList = New ArrayList()
            cStoreLine.GetLineNameAll(objListLines)

            If objListLines.Count = 0 Then Return

            Dim sAuthUser As String = "", sAuthPwd As String = "", sServerAddr As String = "", sAudioCodecList As String = ""
            Dim sToPeerName As String = "", sRoomName As String = "", sQueueName As String = "", sRingGroupName As String = ""
            Dim bRejected As Boolean = False, bRegister As Boolean = False
            Dim nLineType As Integer = cVaxServerCOM.VAX_LINE_TYPE_UDP, nServerPort As Integer = cVaxServerCOM.SIP_DEFAULT_PORT

            For Each sLineName As String In objListLines
                cStoreLine.GetLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
                AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName)
            Next

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
