﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxPickUpGroup

        Public Shared Function AddCallPickUpGroup(ByVal sGroupName As String, ByVal objMemberList As ArrayList) As Boolean

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sGroupName.Length = 0) Then
                Return False
            End If

            RemoveCallPickUpGroup(sGroupName)

            If Not cVaxServerSIP.mVaxSIP.AddCallPickUpGroup(sGroupName) Then
                Return False
            End If

            For Each sMemberName As String In objMemberList
                cVaxServerSIP.mVaxSIP.AddCallPickUpGroupMember(sGroupName, sMemberName)
            Next

            cStoreCallPickUp.AddGroup(sGroupName, objMemberList)

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveCallPickUpGroup(ByVal sGroupName As String)

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sGroupName.Length = 0) Then
                Return
            End If

            cVaxServerSIP.mVaxSIP.RemoveCallPickUpGroup(sGroupName)
            cStoreCallPickUp.RemoveGroup(sGroupName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub LoadCallPickUpGroup()

            If Not cVaxServerSIP.mVaxSIP.IsInitialized() Then
                Return
            End If

            Dim objListNameAll As ArrayList = New ArrayList()
            cStoreCallPickUp.GetGroupNameAll(objListNameAll)

            If objListNameAll.Count = 0 Then Return

            Dim objMemberList As ArrayList = New ArrayList()

            For Each sGroupName As String In objListNameAll
                cStoreCallPickUp.GetGroup(sGroupName, objMemberList)
                AddCallPickUpGroup(sGroupName, objMemberList)
            Next

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
