﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxRingGroup

        Public Sub New()
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sRingGroupName As String, ByRef bProcessed As Boolean)
            bProcessed = False

            If sRingGroupName.Length = 0 Then
                Return
            End If

            If Not cVaxServerSIP.mVaxSIP.AddCallSessionToRingGroup(sRingGroupName, sCallerName, sCallerId, nSessionId) Then Return

            bProcessed = True
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddRingGroup(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer, ByVal objAgentList As ArrayList) As Boolean

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sGroupName.Length = 0) Then
                Return False
            End If

            RemoveRingGroup(sGroupName)

            If Not cVaxServerSIP.mVaxSIP.AddRingGroup(sGroupName) Then
                Return False
            End If

            For Each sAgentName As String In objAgentList
                cVaxServerSIP.mVaxSIP.AddRingGroupAgent(sGroupName, sAgentName)
            Next

            cVaxServerSIP.mVaxSIP.SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType)
            cStoreRingGroup.AddGroup(sGroupName, nProcessMode, nProcessType, objAgentList)

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveRingGroup(ByVal sGroupName As String)

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sGroupName.Length = 0) Then
                Return
            End If

            cVaxServerSIP.mVaxSIP.RemoveRingGroup(sGroupName)
            cStoreRingGroup.RemoveGroup(sGroupName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub LoadRingGroup()

            If Not cVaxServerSIP.mVaxSIP.IsInitialized() Then
                Return
            End If

            Dim objListRingGroup As ArrayList = New ArrayList()
            cStoreRingGroup.GetGroupNameAll(objListRingGroup)

            If objListRingGroup.Count = 0 Then
                Return
            End If

            Dim objAgentList As ArrayList = New ArrayList()
            Dim nProcessMode As Integer = -1, nProcessType As Integer = -1

            For Each sRingGroupName As String In objListRingGroup
                cStoreRingGroup.GetGroup(sRingGroupName, nProcessMode, nProcessType, objAgentList)
                AddRingGroup(sRingGroupName, nProcessMode, nProcessType, objAgentList)
            Next

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
