﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxRoom

        Public Sub New()
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sRoomName As String, ByRef bProcessed As Boolean)

            bProcessed = False

            If sRoomName.Length = 0 Then
                Return
            End If

            If Not cVaxServerSIP.mVaxSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId) Then
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, "Not Found")
                Return
            End If

            If Not cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, "", "", "", "", "") Then
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, "Not Found")
                Return
            End If

            bProcessed = True

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sRoomName.Length = 0) OrElse (sRoomNo.Length = 0) Then
                Return False
            End If

            RemoveRoom(sRoomName)

            If Not cVaxServerSIP.mVaxSIP.OpenConferenceRoom(sRoomName) Then
                RemoveRoom(sRoomName)
                Return False
            End If

            If Not cVaxServerSIP.mVaxSIP.AddConferenceRoomRouteUID(sRoomName, sRoomNo) Then
                RemoveRoom(sRoomName)
                Return False
            End If

            cStoreRoom.AddRoom(sRoomName, sRoomNo)
            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveRoom(ByVal sRoomName As String)

            If cVaxServerSIP.mVaxSIP.IsInitialized() = False OrElse (sRoomName.Length = 0) Then
                Return
            End If

            cVaxServerSIP.mVaxSIP.CloseConferenceRoom(sRoomName)
            cStoreRoom.RemoveRoom(sRoomName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub LoadRoom()

            If Not cVaxServerSIP.mVaxSIP.IsInitialized() Then
                Return
            End If

            Dim objListRoomName As ArrayList = New ArrayList()
            cStoreRoom.GetRoomNameAll(objListRoomName)

            If objListRoomName.Count = 0 Then
                Return
            End If

            Dim sRoomNo As String = ""

            For Each sRoomName As String In objListRoomName
                cStoreRoom.GetRoom(sRoomName, sRoomNo)
                AddRoom(sRoomName, sRoomNo)
            Next

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
