﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxStealthListen

        Private Shared m_nMusicWaitingStealthListenId As Integer = -1

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub ResetAll()
            m_nMusicWaitingStealthListenId = -1
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sRouteUID As String)

            If nFromPeerType <> cVaxServerCOM.VAX_PEER_TYPE_USER OrElse cVaxUser.IsUserTypeAdmin(sFromPeerName) = False Then
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 403, "Forbidden")
                Return
            End If

            cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID)
            cVaxServerSIP.mVaxSIP.AdjustCallSessionVoiceType(nSessionId, -1, cVaxServerCOM.VAX_AUDIO_TYPE_ADMIN)

            StartMusic(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO)

        End Sub

        Public Shared Sub OnStealthListenerAttached(ByVal nAttachType As Integer, ByVal nStealthSessionId As Integer, ByVal nAttachSessionId As Integer, ByVal nAttachChannelId As Integer)

            If nAttachType = cVaxServerCOM.VAX_STEALTH_LISTENER_FREE Then
                StartMusic(nStealthSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO)
            ElseIf nAttachType = cVaxServerCOM.VAX_STEALTH_LISTENER_BUSY Then
                StopMusic(nStealthSessionId)
            End If

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadMusic(ByVal sFileName As String) As Boolean

            If m_nMusicWaitingStealthListenId <> -1 Then
                cVaxServerSIP.mVaxSIP.UnLoadWaveID(m_nMusicWaitingStealthListenId)
                m_nMusicWaitingStealthListenId = -1
            End If

            m_nMusicWaitingStealthListenId = cVaxServerSIP.mVaxSIP.LoadWaveFile(sFileName)
            Return (m_nMusicWaitingStealthListenId <> -1)

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function StartMusic(ByVal nSessionId As Integer, ByVal nChannelId As Integer) As Boolean

            Dim nMusicId As Integer = m_nMusicWaitingStealthListenId
            If nMusicId = -1 Then Return False

            Return cVaxServerSIP.mVaxSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, True, 0)

        End Function

        Private Shared Sub StopMusic(ByVal nSessionId As Integer)

            If m_nMusicWaitingStealthListenId = -1 Then Return

            cVaxServerSIP.mVaxSIP.PlayWaveStopToCallSession(nSessionId, -1, -1)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
