﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Public Class cVaxServerSIP : Inherits cVaxServerCOM

        Public m_objStatusLogDlg As StatusLogForm = Nothing
        Public Shared mVaxSIP As cVaxServerSIP = Nothing

        Private m_nDialToneId As Integer = -1
        Private m_bInitialized As Boolean = False
        Private m_objSessionList As cVaxCallSessionList = Nothing

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub New()
            mVaxSIP = Me
            ResetAll()
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Sub ResetAll()

            m_objSessionList = New cVaxCallSessionList()

            cVaxUser.ResetAll()
            cVaxCallSession.ResetAll()
            cVaxQueue.ResetAll()

            cVaxStealthListen.ResetAll()
            cVaxCallParking.ResetAll()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Function StartServer(ByVal nListenPort As Integer) As Boolean

            StopServer()

            MyBase.SetLicenseKey("TRIAL-LICENSE-KEY")

            If Not MyBase.Initialize("") Then Return False

            If Not MyBase.OpenNetworkUDP("", nListenPort) Then
                UnInitialize()
                Return False
            End If

            If Not MyBase.OpenNetworkTCP("", nListenPort) Then
                UnInitialize()
                Return False
            End If

            If Not MyBase.OpenNetworkTLS("", nListenPort + 1, "") Then
                UnInitialize()
                Return False
            End If

            ' MyBase.AttackDetectScanSIP("demo.vaxvoip.com")
            ' MyBase.AttackDetectFloodSIP(1000)
            ' MyBase.AttackDetectBruteForceSIP(10, 2)

            MyBase.SetListenPortRangeRTP(20000, 30000)
            MyBase.AudioSessionLost(True, 30) 'Enable voice session lost for 30 seconds.
            MyBase.VideoCOMM(True)

            MyBase.AddLine("AnonymousUDP", cVaxServerCOM.VAX_LINE_TYPE_UDP, "", "", "", "", "", "255.255.255.255", -1, "")
            MyBase.AddLine("AnonymousTCP", cVaxServerCOM.VAX_LINE_TYPE_TCP, "", "", "", "", "", "255.255.255.255", -1, "")
            MyBase.AddLine("AnonymousTLS", cVaxServerCOM.VAX_LINE_TYPE_TLS, "", "", "", "", "", "255.255.255.255", -1, "")

            MyBase.AddCallPickUpGroupRouteUID("#5#") 'OnIncomingCall(), OnCallSessionTransferBlind(), sRouteUID Parameter.
            MyBase.AddStealthListenRouteUID("#1#")   'OnIncomingCall(), OnCallSessionTransferBlind(), sRouteUID Parameter.
            MyBase.AddCallParkRouteUID("#3#")        'OnIncomingCall(), OnCallSessionTransferBlind(), sRouteUID Parameter.

            'MyBase.ActivatePushSIP(True, 1)

            m_bInitialized = True
            OnInitialize()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub StopServer()

            m_bInitialized = False
            m_nDialToneId = -1

            MyBase.UnInitialize()
            ResetAll()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Function IsInitialized() As Boolean
            Return m_bInitialized
        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Overloads Function AcceptCallSession(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sToPeerName As String, ByVal sRouteUID As String) As Boolean
            Return MyBase.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, sToPeerName, sRouteUID, 30)
        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Overloads Function DialToneToCallSession(ByVal bEnable As Boolean, ByVal nSessionId As Integer) As Boolean
            If m_nDialToneId = -1 Then Return True
            Return MyBase.DialToneToCallSession(bEnable, nSessionId, m_nDialToneId)
        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Function LoadMusicDialTone(ByVal sFileName As String) As Boolean

            If m_nDialToneId <> -1 Then MyBase.UnLoadWaveID(m_nDialToneId)
            m_nDialToneId = MyBase.LoadWaveFile(sFileName)

            Return (m_nDialToneId <> -1)

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub LoadMusicFiles(ByVal sMusicHold As String, ByVal sMusicDialTone As String, ByVal sMusicCallPark As String)

            MyBase.LoadMusicHold(sMusicHold)
            LoadMusicDialTone(sMusicDialTone)

            cVaxCallParking.LoadMusic(sMusicCallPark)
            cVaxStealthListen.LoadMusic(sMusicCallPark)
            cStoreCOMM.SetMusicFiles(sMusicHold, sMusicDialTone, sMusicCallPark)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Protected Overrides Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)
            m_objSessionList.AddSession(nSessionId)
        End Sub

        Protected Overrides Sub OnCallSessionClosed(nSessionId As Integer, nChannelId As Integer, nReasonCode As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)

            If objCallSession IsNot Nothing Then
                objCallSession.OnCallSessionClosed(nSessionId, nChannelId, nReasonCode)
            End If

            m_objSessionList.RemoveSession(nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnCallSessionAccessAudioPCM(nSessionId As Integer, nChannelId As Integer, nAccessType As Integer, aDataPCM As Byte(), nSizePCM As Integer, nTypePCM As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM)

        End Sub

        Protected Overrides Sub OnCallSessionPushSIP(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal nProviderPN As Integer, ByVal sProjectPN As String, ByVal sDevicePN As String)

            ' Use OnCallSessionPushSIP() event to send Push-Notification to Android and iOS based devices. 
            ' OnCallSessionPushSIP() event triggers only if softphone or SIP client supports Push-SIP RFC.
            ' VaxVoIP Phone SDK iOS & Android already support Push-SIP RFC.

            'MyBase.ActivatePushSIP() VaxServerSDK Exported method. Please search in this Class. Please use it in StartServer() function.

            'If nProviderPN = cVaxServerCOM.VAX_PUSH_PROVIDER_IOS Then

            '    '  Send Notification by using HTTP, Curl.exe or any other method to iOS device. sDevicePN is device token. sProjectPN is APP Name.

            'ElseIf nProviderPN = cVaxServerCOM.VAX_PUSH_PROVIDER_ANDROID Then

            '    ' Send Notification by using HTTP, Curl.exe or any other method to Android device. sDevicePN is device token. sProjectPN is APP Name.

            'End If

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sRouteUID As String, ByVal nRouteType As Integer, ByVal sRouteName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

            If sRouteUID.Length <> 0 Then

                If nRouteType = VAX_ROUTE_TYPE_CALL_PARK Then
                    cVaxCallParking.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, sRouteUID)
                    Return
                End If

                If nRouteType = VAX_ROUTE_TYPE_STEALTH_LISTEN Then
                    cVaxStealthListen.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, nFromPeerType, sFromPeerName, sRouteUID)
                    Return
                End If

                AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID)
                Return
            End If

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            DialToneToCallSession(True, nSessionId)
            objCallSession.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, nFromPeerType, sFromPeerName, sUserAgentName, sFromIP, nFromPort)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String, ByVal sRouteUID As String, ByVal nRouteType As Integer, ByVal sRouteName As String)

            If sRouteUID.Length <> 0 Then

                If nRouteType = VAX_ROUTE_TYPE_CALL_PARK Then
                    cVaxCallParking.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferee, sTransferTo, sRouteUID)
                    Return
                End If

                MyBase.AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, sTransferTo, "", sRouteUID, 30)
                Return

            End If

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nTransfererSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nTransfererSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionTransferConsult(nTransfererSessionId, nTransfererChannelId, nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String, ByVal nTypeDTMF As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnDetectedDigitDTMF(nSessionId, nChannelId, sDigitDTMF)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnLineRegisterTrying(ByVal sLineName As String)
            cVaxLine.OnLineRegisterTrying(sLineName)
        End Sub

        Protected Overrides Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
            cVaxLine.OnLineRegisterFailed(sLineName, nStatusCode, sReasonPhrase)
        End Sub

        Protected Overrides Sub OnLineRegisterSuccess(ByVal sLineName As String)
            cVaxLine.OnLineRegisterSuccess(sLineName)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
            cVaxUser.OnRegisterUser(sUserLogin, sDomain, sUserAgentName, sFromIP, nFromPort, nRegId)
        End Sub

        Protected Overrides Sub OnRegisterUserSuccess(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
            cVaxUser.OnRegisterUserSuccess(sUserLogin, sFromIP, nFromPort, nRegId)
        End Sub

        Protected Overrides Sub OnRegisterUserFailed(ByVal sUserLogin As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal nRegId As Integer)
            cVaxUser.OnRegisterUserFailed(sUserLogin, sFromIP, nFromPort, nRegId)
        End Sub

        Protected Overrides Sub OnUnRegisterUser(ByVal sUserLogin As String)
            cVaxUser.OnUnRegisterUser(sUserLogin)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnChatMessageText(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
            MyBase.AcceptChatMessage(nChatMsgId, sMsgTo)
        End Sub

        Protected Overrides Sub OnChatMessageTyping(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal bIsTypingStart As Boolean, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
            MyBase.AcceptChatMessage(nChatMsgId, sMsgTo)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnChatStatusSubscribe(ByVal nSubscrbId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
            MyBase.AcceptChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo, sMsgTo)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnBusyLampSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
            MyBase.BusyLampSubscribeAccept(nSubScrbId, True, 30)
        End Sub

        Protected Overrides Sub OnBusyLampSendStatus(ByVal sFromUserName As String, ByVal sToUserName As String, ByVal nStateId As Integer)
            MyBase.BusyLampSendStatus(sFromUserName, sToUserName, nStateId)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnQueuePlayWaveStarted(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnQueuePlayWaveStarted(nEventType, sQueueName, nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnQueuePlayWaveEnded(ByVal nEventType As Integer, ByVal sQueueName As String, ByVal nSessionId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnQueuePlayWaveEnded(nEventType, sQueueName, nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnStealthListenerAttached(ByVal nAttachType As Integer, ByVal nStealthSessionId As Integer, ByVal nAttachSessionId As Integer, ByVal nAttachChannelId As Integer)
            cVaxStealthListen.OnStealthListenerAttached(nAttachType, nStealthSessionId, nAttachSessionId, nAttachChannelId)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Protected Overrides Sub OnCallSessionConnected(ByVal nSessionId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionConnected(nSessionId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Protected Overrides Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionMediaDetectStartedVAD(nSessionId, nChannelId)

        End Sub

        Protected Overrides Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionMediaDetectCompletedVAD(nSessionId, nChannelId, aDataPCM, nSizePCM, nTypePCM)

        End Sub

        Protected Overrides Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

            Dim objCallSession As cVaxCallSession = m_objSessionList.GetSession(nSessionId)
            If objCallSession Is Nothing Then Return

            objCallSession.OnCallSessionMediaDetectExpiredVAD(nSessionId, nChannelId)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub GenStatusLog(ByVal sStatus As String)
            OnStatusLog(sStatus)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Protected Overrides Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
            Dim sMsg As String = "[Method: " & sFuncName & "] [Error Msg: " & sErrorMsg & "] [Code: " & nErrorCode.ToString() & "]"
            OnStatusLog(sMsg)
        End Sub

        Protected Overrides Sub OnCallSessionErrorLog(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
            Dim sMsg As String = "[Session: " & nSessionId.ToString() & "] [Error Msg: " & sErrorMsg & "] [Code: " & nErrorCode.ToString() & "]"
            OnStatusLog(sMsg)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Sub OnInitialize()

            If Not cVaxSettingDefault.LoadUserDefault() Then
                cVaxUser.LoadUser()
            End If

            If Not cVaxSettingDefault.LoadQueueDefault() Then
                cVaxQueue.LoadQueue()
            End If

            If Not cVaxSettingDefault.LoadRingGroupDefault() Then
                cVaxRingGroup.LoadRingGroup()
            End If

            If Not cVaxSettingDefault.LoadCallPickUpGroupDefault() Then
                cVaxPickUpGroup.LoadCallPickUpGroup()
            End If

            If Not cVaxSettingDefault.LoadRoomDefault() Then
                cVaxRoom.LoadRoom()
            End If

            If Not cVaxSettingDefault.LoadLineDefault() Then
                cVaxLine.LoadLine()
            End If

        End Sub

        Private Sub OnStatusLog(ByVal sMsg As String)
            m_objStatusLogDlg.OnStatusLog(sMsg)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
