﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cVaxSettingDefault

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadUserDefault() As Boolean

            If cStoreUser.IsDataStored() Then
                Return False
            End If

            For nCount As Integer = 4000 To 4050
                cVaxUser.AddUser(nCount.ToString(), nCount.ToString(), "32014", False, cVaxServerCOM.VAX_AUDIO_TYPE_NORMAL, "", "", "")
            Next

            For nCount As Integer = 6000 To 6020
                cVaxUser.AddUser(nCount.ToString(), nCount.ToString(), "32014", False, cVaxServerCOM.VAX_AUDIO_TYPE_USER, "", "", "")
            Next

            For nCount As Integer = 8000 To 8020
                cVaxUser.AddUser(nCount.ToString(), nCount.ToString(), "32014", False, cVaxServerCOM.VAX_AUDIO_TYPE_ADMIN, "", "", "")
            Next

            Return True

        End Function

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadQueueDefault() As Boolean

            If cStoreQueue.IsDataStored() Then
                Return False
            End If

            Dim objAgentList As ArrayList = New ArrayList() From {"6000", "6001", "6002", "6003", "6004", "6005"}
            cVaxQueue.AddQueue("QueueTech", cVaxServerCOM.VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN, cVaxServerCOM.VAX_QUEUE_PROCESS_TYPE_FREE, objAgentList, cVaxDefine.MUSIC_FILE_QUEUE, cVaxDefine.MUSIC_FILE_DIAL_TONE)

            objAgentList = New ArrayList() From {"6010", "6011", "6012", "6013", "6014", "6015"}
            cVaxQueue.AddQueue("QueueSales", cVaxServerCOM.VAX_QUEUE_PROCESS_MODE_HUNT_RANDOM, cVaxServerCOM.VAX_QUEUE_PROCESS_TYPE_FREE, objAgentList, cVaxDefine.MUSIC_FILE_QUEUE, cVaxDefine.MUSIC_FILE_DIAL_TONE)

            Return True

        End Function

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadRingGroupDefault() As Boolean

            If cStoreRingGroup.IsDataStored() Then
                Return False
            End If

            Dim objAgentList As ArrayList = New ArrayList() From {"4000", "4001", "4002", "4003", "4004", "4005"}
            cVaxRingGroup.AddRingGroup("RingGroupTech", cVaxServerCOM.VAX_RING_GROUP_PROCESS_MODE_RING_ALL, cVaxServerCOM.VAX_RING_GROUP_PROCESS_TYPE_FREE, objAgentList)

            objAgentList = New ArrayList() From {"4010", "4011", "4012", "4013", "4014", "4015"}
            cVaxRingGroup.AddRingGroup("RingGroupDesign", cVaxServerCOM.VAX_RING_GROUP_PROCESS_MODE_HUNT_RANDOM, cVaxServerCOM.VAX_RING_GROUP_PROCESS_TYPE_FREE, objAgentList)

            Return True

        End Function

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadCallPickUpGroupDefault() As Boolean

            If cStoreCallPickUp.IsDataStored() Then
                Return False
            End If

            Dim objMemberList As ArrayList = New ArrayList() From {"4000", "4001", "4002", "4003", "4004", "4005"}
            cVaxPickUpGroup.AddCallPickUpGroup("PickUpTech", objMemberList)

            objMemberList = New ArrayList() From {"4010", "4011", "4012", "4013", "4014", "4015"}
            cVaxPickUpGroup.AddCallPickUpGroup("PickUpDesign", objMemberList)

            Return True

        End Function

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadLineDefault() As Boolean

            If cStoreLine.IsDataStored() Then
                Return False
            End If

            cVaxLine.AddLine("LineServiceProviderTech", cVaxServerCOM.VAX_LINE_TYPE_UDP, "9090", "9090", "192.168.0.119", 5060, "32", False, "", False, "", "QueueTech", "")
            cVaxLine.AddLine("LineServiceProviderDesign", cVaxServerCOM.VAX_LINE_TYPE_UDP, "9092", "9092", "192.168.0.119", 5060, "32", False, "", False, "", "QueueSales", "")

            Return True

        End Function

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

        Public Shared Function LoadRoomDefault() As Boolean

            If cStoreRoom.IsDataStored() Then
                Return False
            End If

            cVaxRoom.AddRoom("RoomTech", "20021")
            cVaxRoom.AddRoom("RoomDesign", "20022")

            Return True

        End Function

        '/////////////////////////////////////////////////////////////////////////////////
        '/////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
