﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cStoreCallPickUp

        Const CALL_PICKUP_GROUP_ROOT_PATH As String = "CallPickUpGroups\"

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddGroup(ByVal sGroupName As String, ByVal objMemberList As ArrayList) As Boolean

            RemoveGroup(sGroupName)

            If sGroupName.Length = 0 Then
                Return False
            End If

            Dim sKeyPath As String = CALL_PICKUP_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetTEXT(sKeyPath, "CallPickUpGroupName", sGroupName)

            For Each sMemberName As String In objMemberList
                cStoreCallPickUp.AddGroupMember(sGroupName, sMemberName)
            Next

            objStore.Close()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveGroup(ByVal sGroupName As String)

            If sGroupName.Length = 0 Then
                Return
            End If

            Dim sKeyPath As String = CALL_PICKUP_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetGroupNameAll(ByRef objList As ArrayList)

            objList.Clear()

            Dim sKeyPath As String = CALL_PICKUP_GROUP_ROOT_PATH
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function GetGroup(ByVal sGroupName As String, ByRef objMemberList As ArrayList) As Boolean

            If sGroupName.Length = 0 Then
                Return False
            End If

            cStoreCallPickUp.GetMemberNameAll(sGroupName, objMemberList)

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function AddGroupMember(ByVal sGroupName As String, ByVal sUserName As String) As Boolean

            If sGroupName.Length = 0 OrElse sUserName.Length = 0 Then Return False

            Dim sKeyPath As String = CALL_PICKUP_GROUP_ROOT_PATH & sGroupName & "\" & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            Dim bResult As Boolean = objStore.SetTEXT(sKeyPath, "UserName", sUserName)
            objStore.Close()

            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub RemoveGroupMember(ByVal sGroupName As String, ByVal sUserName As String)

            If sGroupName.Length = 0 OrElse sUserName.Length = 0 Then Return

            Dim sKeyPath As String = CALL_PICKUP_GROUP_ROOT_PATH & sGroupName & "\" & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub GetMemberNameAll(ByVal sGroupName As String, ByRef objList As ArrayList)

            objList.Clear()

            If sGroupName.Length = 0 Then Return

            Dim sKeyPath As String = CALL_PICKUP_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function IsDataStored() As Boolean

            Dim objStore As cStoreRegistry = New cStoreRegistry()
            Dim bResult As Boolean = objStore.IsKeyExist(CALL_PICKUP_GROUP_ROOT_PATH)

            objStore.Close()
            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
