﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cStoreQueue

        Const QUEUE_ROOT_PATH As String = "Queues\"

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddQueue(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer, ByVal objAgentList As ArrayList, ByVal sMusicFileName As String, ByVal sDialToneFileName As String) As Boolean

            RemoveQueue(sQueueName)

            If sQueueName.Length = 0 Then Return False

            Dim sKeyPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            If Not objStore.SetTEXT(sKeyPath, "QueueName", sQueueName) Then
                objStore.Close()
                Return False
            End If

            cStoreQueue.AddQueueAgentNameAll(sQueueName, objAgentList)
            cStoreQueue.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType)
            cStoreQueue.SetMediaFiles(sQueueName, sMusicFileName, sDialToneFileName)

            objStore.Close()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveQueue(ByVal sQueueName As String)

            If sQueueName.Length = 0 Then Return

            Dim sKeyPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetQueueNameAll(ByRef objList As ArrayList)

            objList.Clear()

            Dim sKeyPath As String = QUEUE_ROOT_PATH
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetQueue(ByVal sQueueName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef objAgentList As ArrayList, ByRef sMusicFileName As String, ByRef sDialToneFileName As String)

            cStoreQueue.GetQueueProcessMode(sQueueName, nProcessMode, nProcessType)
            cStoreQueue.GetQueueAgentNameAll(sQueueName, objAgentList)
            cStoreQueue.GetMediaFiles(sQueueName, sMusicFileName, sDialToneFileName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function SetMediaFiles(ByVal sQueueName As String, ByVal sMusicFileName As String, ByVal sDialToneFileName As String) As Boolean

            Dim sPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetTEXT(sPath, "MusicFileName", sMusicFileName)
            objStore.SetTEXT(sPath, "DialToneFileName", sDialToneFileName)
            objStore.Close()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub GetMediaFiles(ByVal sQueueName As String, ByRef sMusicFileName As String, ByRef sDialToneFileName As String)

            Dim sPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetTEXT(sPath, "MusicFileName", sMusicFileName, cVaxDefine.MUSIC_FILE_QUEUE)
            objStore.GetTEXT(sPath, "DialToneFileName", sDialToneFileName, cVaxDefine.MUSIC_FILE_DIAL_TONE)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer) As Boolean

            If sQueueName.Length = 0 Then Return False

            Dim sKeyPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetINT(sKeyPath, "ProcessMode", nProcessMode)
            objStore.SetINT(sKeyPath, "ProcessType", nProcessType)
            objStore.Close()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub GetQueueProcessMode(ByVal sQueueName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer)

            Dim sKeyPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetINT(sKeyPath, "ProcessMode", nProcessMode, cVaxServerCOM.VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN)
            objStore.GetINT(sKeyPath, "ProcessType", nProcessType, cVaxServerCOM.VAX_QUEUE_PROCESS_TYPE_FREE)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub AddQueueAgentNameAll(ByVal sQueueName As String, ByVal objList As ArrayList)

            If sQueueName.Length = 0 Then Return

            Dim objStore As cStoreRegistry = New cStoreRegistry()

            For Each sUserName As String In objList
                Dim sKeyPath As String = QUEUE_ROOT_PATH & sQueueName & "\" & sUserName
                objStore.SetTEXT(sKeyPath, "UserName", sUserName)
            Next

            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetQueueAgentNameAll(ByVal sQueueName As String, ByRef objList As ArrayList)

            objList.Clear()

            Dim sKeyPath As String = QUEUE_ROOT_PATH & sQueueName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function IsDataStored() As Boolean

            Dim objStore As cStoreRegistry = New cStoreRegistry()

            Dim bResult As Boolean = objStore.IsKeyExist(QUEUE_ROOT_PATH)
            objStore.Close()

            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
