﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cStoreRingGroup

        Const RING_GROUP_ROOT_PATH As String = "RingGroups\"

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddGroup(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer, ByVal objAgentList As ArrayList) As Boolean

            RemoveGroup(sGroupName)

            If sGroupName.Length = 0 Then
                Return False
            End If

            Dim sKeyPath As String = RING_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            If Not objStore.SetTEXT(sKeyPath, "RingGroupName", sGroupName) Then
                objStore.Close()
                Return False
            End If

            cStoreRingGroup.AddGroupAgentNameAll(sGroupName, objAgentList)
            cStoreRingGroup.SetGroupProcessMode(sGroupName, nProcessMode, nProcessType)

            objStore.Close()

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveGroup(ByVal sGroupName As String)

            If sGroupName.Length = 0 Then
                Return
            End If

            Dim sKeyPath As String = RING_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetGroupNameAll(ByRef objList As ArrayList)

            Dim sKeyPath As String = RING_GROUP_ROOT_PATH
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function GetGroup(ByVal sGroupName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef objAgentList As ArrayList) As Boolean

            If sGroupName.Length = 0 Then
                Return False
            End If

            cStoreRingGroup.GetGroupAgentNameAll(sGroupName, objAgentList)
            cStoreRingGroup.GetGroupProcessMode(sGroupName, nProcessMode, nProcessType)

            Return True

        End Function

        Private Shared Function SetGroupProcessMode(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer) As Boolean

            If sGroupName.Length = 0 Then
                Return False
            End If

            Dim sKeyPath As String = RING_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetINT(sKeyPath, "ProcessMode", nProcessMode)
            objStore.SetINT(sKeyPath, "ProcessType", nProcessType)

            objStore.Close()
            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function GetGroupProcessMode(ByVal sGroupName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer) As Boolean

            If sGroupName.Length = 0 Then
                Return False
            End If

            Dim sKeyPath As String = RING_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetINT(sKeyPath, "ProcessMode", nProcessMode, cVaxServerCOM.VAX_RING_GROUP_PROCESS_MODE_RING_ALL)
            objStore.GetINT(sKeyPath, "ProcessType", nProcessType, cVaxServerCOM.VAX_RING_GROUP_PROCESS_TYPE_FREE)

            objStore.Close()
            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub AddGroupAgentNameAll(ByVal sGroupName As String, ByVal objList As ArrayList)

            If sGroupName.Length = 0 Then
                Return
            End If

            Dim objStore As cStoreRegistry = New cStoreRegistry()

            For Each sUserName As String In objList
                Dim sKeyPath As String = RING_GROUP_ROOT_PATH & sGroupName & "\" & sUserName
                objStore.SetTEXT(sKeyPath, "UserName", sUserName)
            Next

            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub GetGroupAgentNameAll(ByVal sGroupName As String, ByRef objList As ArrayList)

            If sGroupName.Length = 0 Then
                Return
            End If

            Dim sKeyPath As String = RING_GROUP_ROOT_PATH & sGroupName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function IsDataStored() As Boolean

            Dim objStore As cStoreRegistry = New cStoreRegistry()
            Dim bResult As Boolean = objStore.IsKeyExist(RING_GROUP_ROOT_PATH)

            objStore.Close()
            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
