﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cStoreRoom

        Const ROOM_ROOT_PATH As String = "Rooms\"

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean

            If sRoomName.Length = 0 Then Return False

            Dim sKeyPath As String = ROOM_ROOT_PATH & sRoomName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            Dim bResult As Boolean = objStore.SetTEXT(sKeyPath, "RoomNo", sRoomNo)
            objStore.Close()

            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetRoom(ByVal sRoomName As String, ByRef sRoomNo As String)

            Dim sKeyPath As String = ROOM_ROOT_PATH & sRoomName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetTEXT(sKeyPath, "RoomNo", sRoomNo, "")
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveRoom(ByVal sRoomName As String)

            If sRoomName.Length = 0 Then Return

            Dim sKeyPath As String = ROOM_ROOT_PATH & sRoomName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetRoomNameAll(ByRef objList As ArrayList)

            objList.Clear()

            Dim sKeyPath As String = ROOM_ROOT_PATH
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function IsDataStored() As Boolean

            Dim objStore As cStoreRegistry = New cStoreRegistry()
            Dim bResult As Boolean = objStore.IsKeyExist(ROOM_ROOT_PATH)

            objStore.Close()
            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
    End Class
End Namespace
