﻿Imports System
Imports System.Collections

Namespace ServerSIP

    Class cStoreUser

        Const USER_ROOT_PATH As String = "Users\"

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sAudioCodecList As String, ByVal bBlocked As Boolean, ByVal nVoiceTypeId As Integer, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal sToPeerName As String) As Boolean

            If sUserName.Length = 0 Then Return False

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetTEXT(sKeyPath, "UserName", sUserName)
            objStore.SetTEXT(sKeyPath, "Password", sPassword)

            objStore.SetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList)
            objStore.SetBOOL(sKeyPath, "Blocked", bBlocked)
            objStore.SetINT(sKeyPath, "VoiceTypeId", nVoiceTypeId)

            objStore.Close()
            cStoreUser.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, sToPeerName)

            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetUser(ByVal sUserName As String, ByRef sPassword As String, ByRef sAudioCodecList As String, ByRef bBlocked As Boolean, ByRef nVoiceTypeId As Integer, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef sToPeerName As String)

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetTEXT(sKeyPath, "Password", sPassword, "")
            objStore.GetTEXT(sKeyPath, "AudioCodecList", sAudioCodecList, "")

            objStore.GetBOOL(sKeyPath, "Blocked", bBlocked, False)
            objStore.GetINT(sKeyPath, "VoiceTypeId", nVoiceTypeId, cVaxServerCOM.VAX_AUDIO_TYPE_NORMAL)

            objStore.Close()
            cStoreUser.GetUserRoute(sUserName, sUserPrefix, sDialPrefix, sToPeerName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub RemoveUser(ByVal sUserName As String)

            If sUserName.Length = 0 Then Return

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteSubKey(sKeyPath)
            objStore.Close()

            RemoveUserRoute(sUserName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub GetUserAll(ByRef objList As ArrayList)

            Dim sKeyPath As String = USER_ROOT_PATH
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.EnumSubKeys(sKeyPath, objList)
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Function AddUserRoute(ByVal sUserName As String, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal sToPeerName As String) As Boolean

            If sUserName.Length = 0 Then Return False

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.SetTEXT(sKeyPath, "UserPrefix", sUserPrefix)
            objStore.SetTEXT(sKeyPath, "DialPrefix", sDialPrefix)
            objStore.SetTEXT(sKeyPath, "ToPeerName", sToPeerName)

            objStore.Close()
            Return True

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub GetUserRoute(ByVal sUserName As String, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef sToPeerName As String)

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.GetTEXT(sKeyPath, "UserPrefix", sUserPrefix, "")
            objStore.GetTEXT(sKeyPath, "DialPrefix", sDialPrefix, "")

            objStore.GetTEXT(sKeyPath, "ToPeerName", sToPeerName, "")
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Shared Sub RemoveUserRoute(ByVal sUserName As String)

            If sUserName.Length = 0 Then Return

            Dim sKeyPath As String = USER_ROOT_PATH & sUserName
            Dim objStore As cStoreRegistry = New cStoreRegistry()

            objStore.DeleteValue(sKeyPath, "UserPrefix")
            objStore.DeleteValue(sKeyPath, "DialPrefix")

            objStore.DeleteValue(sKeyPath, "ToPeerName")
            objStore.Close()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Function IsDataStored() As Boolean

            Dim objStore As cStoreRegistry = New cStoreRegistry()
            Dim bResult As Boolean = objStore.IsKeyExist(USER_ROOT_PATH)

            objStore.Close()
            Return bResult

        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
